package com.wyattjmiller.data

import io.ktor.server.auth.*
import org.ktorm.entity.Entity
import org.ktorm.schema.Table
import org.ktorm.schema.datetime
import org.ktorm.schema.int
import org.ktorm.schema.varchar
import java.time.LocalDateTime

object DbUserTable : Table<Users>("user") {
    val id = int("id").primaryKey().bindTo { it.id }
    val firstName = varchar("first_name").bindTo { it.firstName }
    val lastName = varchar("last_name").bindTo { it.lastName }
    val username = varchar("username").bindTo { it.username }
    val password = varchar("password").bindTo { it.password }
    val emailAddress = varchar("email_address").bindTo { it.emailAddress }
    val createdTimestamp = datetime("created_timestamp").bindTo { it.createdTimestamp }
    //val createdAuthors = int("created_authors").references(DbAuthorTable) { it.createdAuthors }
}

interface Users : Entity<Users> {
    companion object : Entity.Factory<Users>()

    val id: Int
    val firstName: String
    val lastName: String
    val username: String
    val password: String
    val emailAddress: String
    val createdTimestamp: LocalDateTime
    //val createdAuthors get() = listOf(DbAuthorTable.id)
}